﻿/**
* feedpeep v1.0 - An application for studying color data through time from RSS feeds.
* 
* @author Eva Casado de Amezua . e_luanco@uoc.edu . www.ellaing.com
* @version 1.0
* 
* This application is offered as is and licensed under a Creative Commons Attribution-NonCommercial-NoDerivs 3.0 Unported License.
* Functions averageColour(), isCold(), different(), similar(), uniqueColours(), indexColours() and reduceColours() by Justin Windle (http://blog.soulwire.co.uk/ ).
*/

package com.core {
	
	import flash.display.*;
	import flash.geom.*;
	import flash.text.*;
	import flash.events.*; 
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import com.utils.*;

	public class graphItem extends MovieClip {
		
		private var id:int = 0;
		private var iUrl:String = "";
		private var iBitMap:Bitmap;
		private var iBitMapData:BitmapData;
		private var pubDate:Date;
		private var iAverageColor:uint;
		private var iMC:MovieClip;
		private var red:int;
		private var green:int;
		private var blue:int;
		private var avColorRGB:Array;
		private var luminosity:int;
		private var hsv_hue:int;
		private var hsv_saturation:Number;
		private var hsv_value:int;
		private var indexedColours:Array;
		private var uniqueColours:Array;
		private var uColours:Array;
		private var image_mc:MovieClip = new MovieClip();
		private var timeline_mc:MovieClip = new MovieClip();
		private var rectBig:MovieClip = new MovieClip();
		private var rectSmall:MovieClip = new MovieClip();
		private var t:TextField = new TextField();
		private var loadedBitmap:Bitmap;
		private var loader:Loader = new Loader();
		private var imageCold:Boolean;
		private var bgDataView:MovieClip = new MovieClip();
		private var prevailingColorF:int;
		private var featuredColor:uint;
		private var HSV:Object = {};
		private var __parent_movieclip:MovieClip
		private var __yOffset:int;
		private var flag_ready:int = 0;
		public var processedDate:int;

		public function graphItem(p_iUrl:String, p_date:Date, parent_movieclip:MovieClip) {
			set_url(p_iUrl);
			set_date(p_date);
			set_pDate(p_date);
			set_parentMc(parent_movieclip);
			__yOffset = 340;
			}
			
		public function createMC(p_b:BitmapData):void {
			stringUtils.writeTrace(0, "createMC");
			
			image_mc.visible = false;
			set_indexedColours(p_b);
			set_uniqueColours();
			loader.visible = false;
			image_mc.addChild(loader);
			
			bgDataView.graphics.beginFill(0xB8B3B1);
			bgDataView.graphics.drawRoundRect(0, 0, 130, 100, 20);
			bgDataView.graphics.endFill();
			bgDataView.visible = false;
			image_mc.addChild(bgDataView);
			bgDataView.x += 25;
			bgDataView.alpha = 0.7;
			
			var f:Font = new Font1(); 
			var tf:TextFormat = new TextFormat();
			tf.font = f.fontName;
			tf.size = 11;
			t.autoSize = TextFieldAutoSize.LEFT;
			t.defaultTextFormat = tf;
			t.embedFonts = true;

			rectBig.graphics.beginFill(0xFF0000);
			var colorTransform:ColorTransform = rectBig.transform.colorTransform;
			colorTransform.color = uniqueColours[0].colour;
			
			prepareBitmap(p_b);
			set_averageColor(colorTransform.color);
			prevailingColorF = imageTools.prevailingColorFamily(colorTransform.color);
			set_featuredColor();
			set_bitmap(p_b);
			
			t.visible = false;
			var s:String = "\n";
			t.text = "date:" + get_pDate().toString() + s + "hue: " + get_hue() + s + "saturation: " + int(get_saturation()*10)/10+ s + "value: " + get_value() + s + "cold: " + get_temperature() + s + "color family: " + imageTools.colorFamilyNameDesc(this.prevailingColorF, true, false) + s + "R:" + this.red + " G:" + this.green + " B:"+ this.blue + s + "HEX: #" + get_averageColor().toString(16).toUpperCase();
			t.x += 10;
			bgDataView.addChild(t);

			rectBig.graphics.drawRect(0, 0, 20, 20);
			rectBig.graphics.endFill();
			rectBig.transform.colorTransform = colorTransform;
			image_mc.addChild(rectBig);
			
			rectSmall.graphics.beginFill(0xFF0000);
			var colorTransform2:ColorTransform = rectBig.transform.colorTransform;
			colorTransform2.color = get_featuredColor();
			rectSmall.graphics.drawRect(0, 0, 10, 10);
			rectSmall.graphics.endFill();
			rectSmall.transform.colorTransform = colorTransform2;
			rectSmall.y = 5;
			rectSmall.x = 5;
			image_mc.addChild(rectSmall);
			
			image_mc.buttonMode = true;
			image_mc.useHandCursor = true;
			image_mc.addEventListener(MouseEvent.CLICK , viewImage);
			image_mc.addEventListener(MouseEvent.ROLL_OVER , viewData);
			
			rearrangeLoader();
			this.flag_ready = 1;
			var evt = new imageLoadEvent(imageLoadEvent.LOAD_COMPLETED, { flag:get_flag(), id:get_id() } );
			dispatchEvent(evt);
			trace(evt.type);
			
			stringUtils.writeTrace(1, "item", get_id());
			}
	
		private function bringToFront(mc:MovieClip, parent:MovieClip):void { 
		    var pos:Number = parent.getChildIndex(mc) 
		    while(pos < parent.numChildren - 1){ 
			   var next:MovieClip = parent.getChildAt(pos+1) as MovieClip 
			   parent.swapChildren(mc,next) 
			   pos = parent.getChildIndex(mc) 
				} 
			}
	
		public function viewImage(e:MouseEvent):void{
			if(loader.visible == false){
				loader.visible = true;
				loader.y = (250 - image_mc.y) + __yOffset;
				bringToFront(image_mc, this.get_parentMC()  );
				bringToFront(bgDataView, image_mc  );
				}else {
					loader.visible = false;
				}
			}
			
		public function forceViewImage():void{
				loader.visible = true;
				}	
		
		public function forceHideImage():void{
				loader.visible = false;
				}
			
		public function rearrangeLoader():void {
				loader.y = (250 - image_mc.y) + __yOffset;
				bringToFront(image_mc, this.get_parentMC());
				bringToFront(bgDataView, image_mc);	
			}	
	
		private function viewData(e:MouseEvent):void {
			switchDataVisibility();
			image_mc.removeEventListener(MouseEvent.ROLL_OVER, viewData);
			image_mc.addEventListener(MouseEvent.ROLL_OUT, hideData, false, 0, true);
			bringToFront(image_mc, this.get_parentMC()  );
			bringToFront(bgDataView, image_mc  );
			}

		private function hideData(e:MouseEvent):void {
			switchDataVisibility();
			image_mc.removeEventListener(MouseEvent.ROLL_OUT, hideData);
			image_mc.addEventListener(MouseEvent.ROLL_OVER, viewData, false, 0, true);
			}

		public function switchDataVisibility():void {
			if (t.visible == false || bgDataView.visible == false) {
				t.visible = true;
				bgDataView.visible = true;
				bringToFront(this.get_image_mc(), this.get_parentMC()  );
				}else {
					t.visible = false;
					bgDataView.visible = false;
					}
			}

		private function hideLoader():void {
			loader.visible = false;
			}	
	
		public function loadImage():void  {  
			loader.contentLoaderInfo.addEventListener(Event.COMPLETE, loadBitmap); 
			var tmpUrl:String = get_url();
			var httpControl:String = tmpUrl.slice(0,4);
			if (httpControl != "http") {
				tmpUrl = "xml/rss/" + get_url();
				}
			if (tmpUrl.length>=10) {
				loader.load(new URLRequest(tmpUrl));
				}
			
			} 
		private function loadBitmap(e:Event):void  {  
			controlBitmapSize();
			stringUtils.writeTrace(0, "loadBitmap");
			e.target.removeEventListener(Event.COMPLETE, loadBitmap);
			loadedBitmap = new Bitmap(e.target.loader.contentLoaderInfo.content.bitmapData.clone());  
			
			var scale:Number = 1;
			var b_width:Number = loadedBitmap.bitmapData.width;
			var b_height:Number = loadedBitmap.bitmapData.height
			
			if (b_width >= b_height + 1 ) { 
				scale = 1/(b_width / 240) 
				} 
			if (b_width <= b_height ) { 
				scale = 1/(b_height / 160);
				}
			if (b_width == 240 || b_height == 240) { 
				scale = 1;
				}
			
			var matrix:Matrix = new Matrix();
			matrix.scale(scale, scale);
			b_width = loadedBitmap.bitmapData.width * scale;
			b_height = loadedBitmap.bitmapData.height * scale;
			var smallBMD:BitmapData = new BitmapData(b_width, b_height, true, 0x000000);
			smallBMD.draw(loadedBitmap, matrix, null, null, null, true);
			var scaledBitmap:Bitmap = new Bitmap(smallBMD, PixelSnapping.NEVER, true);
			loadMC(scaledBitmap);
			}
			
		private function controlBitmapSize():void {
			if(loader.width >= loader.height){
				if (loader.width >= 241 || loader.width <= 239) {
					loader.width = 240;
					loader.height = 160;
					}
				} else {
					if (loader.height >= 241 || loader.height <= 239) {
						loader.width = 160;
						loader.height = 240;
						}
				}
			}

		private function loadMC(p_b:Bitmap){
			stringUtils.writeTrace(0, "loadMC");
			set_temperature(p_b.bitmapData);
			createMC(p_b.bitmapData);
			}

		private function prepareBitmap(p_bitmap:BitmapData):void{
			stringUtils.writeTrace(0, "prepareBitmap");
			iBitMapData=p_bitmap;
			}

/* SETTERS ------------------------------------------------------------------------------------------------------------------*/

		private function set_parentMc(mc:MovieClip){
			__parent_movieclip = mc;
			}
			
		private function set_date(p_date:Date):void{
			pubDate=p_date;
			}

		private function set_pDate(p_pDate:Date):void{
			processedDate=calcTools.processDate(p_pDate);
			}

		public function set_id(p_id:int):void{
			this.id = p_id;
			}

		private function set_url(p_iUrl:String):void{
			iUrl=p_iUrl;
			}

		private function set_bitmap(p_bitmap:BitmapData):void {
			stringUtils.writeTrace(0,"set_bitmap");
			iBitMap = new Bitmap(p_bitmap.clone()); 
			}
			  
		private function set_averageColor(p_avcolor:uint):void {
			stringUtils.writeTrace(0, "set_averageColor");
			iAverageColor = p_avcolor;
			this.red = imageTools.extractRed(p_avcolor);
			this.green = imageTools.extractGreen(p_avcolor);
			this.blue = imageTools.extractBlue(p_avcolor);
			avColorRGB = [red, green, blue];
			set_HSV();
			var t_cValues:String = this.red.toString() + "." + this.green.toString() + "." + this.blue.toString();
			stringUtils.writeTrace(1, "R.G.B", t_cValues);
			}
		
		private function set_movieclip(p_mc:MovieClip):void{
			iMC=new MovieClip();
			iMC=p_mc;
			}
			
		private function set_HSV():void {
			this.HSV = imageTools.RGBtoHSV(this.red, this.green, this.blue);
			}
			
		private function set_temperature(p_b:BitmapData):void {
			imageCold=imageTools.isCold(p_b);
			}

		private function set_indexedColours(p_b:BitmapData):void {
			stringUtils.writeTrace(0, "set_indexedColours");
			indexedColours = imageTools.indexColours(p_b, true);
			}

		private function set_uniqueColours():void {
			stringUtils.writeTrace(0, "set_uniqueColours");
			uniqueColours = imageTools.uniqueColours(indexedColours, 16, 0.005);
			}
			 
		private function set_featuredColor():void {
			featuredColor = imageTools.getFeaturedColor(uniqueColours, prevailingColorF);
			stringUtils.writeTrace(1, "featuredColor", featuredColor.toString());
			}
	  
/* GETTERS ------------------------------------------------------------------------------------------------------------------*/
	  
		public function get_image_mc():MovieClip{
			return image_mc;
			}

		public function get_id():int{
			return this.id;
			}

		public function get_date():Date{
			return pubDate;
			}

		public function get_pDate():int{
			return processedDate;
			}

		public function get_url():String{
			return iUrl;
			}
			  
		public function get_bitmap():Bitmap{
			return iBitMap;
			}
		  
		public function get_bitmapdata():BitmapData {
			return iBitMapData;
			}

		public function get_averageColor():uint {
			return iAverageColor;
			}
		  
		public function get_luminosity():int {
			return luminosity;
			}
		
		public function get_loader():Loader {
			return loader;
			}	
			
		public function get_temperature():Boolean {
			return imageCold;
			}
			   
		public function get_value():int{
			return this.HSV.V;
			}
					  
		public function get_saturation():Number{
			return this.HSV.S;
			}
			  
		public function get_hue():int{
			return this.HSV.H;
			}
			
		public function get_firstuniquecolour():uint{
			return 0;
			}
				
		public function get_firstindexedcolour():uint{
			return indexedColours[0];
			}

		public function get_prevailingColor():int {
			return prevailingColorF;
			}
		
		public function get_featuredColor():int {
			return featuredColor;
			}
		public function get_flag():int {
			return this.flag_ready;
			}
		public function get_parentMC():MovieClip {
			return this.__parent_movieclip;
			}
			
   }
   
}
